<?php

defined('_JEXEC') or die('Restricted access');

require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/library/plugins/payment.php');
require_once (JPATH_ADMINISTRATOR.'/components/com_j2store/helpers/j2store.php');

class plgJ2StorePayment_pas extends J2StorePaymentPlugin
{
    /**
     * @var $_element  string  Should always correspond with the plugin's filename,
     *                         forcing it to be unique
     */
    var $_element   = 'payment_pas';
    private $merchantCode = '';
    private $callBackUrl = '';


    public function __construct(& $subject, $config)
    {
        parent::__construct($subject, $config);
        $this->loadLanguage( '', JPATH_ADMINISTRATOR );
        $this->merchantCode = trim($this->params->get('merchant_id'));
        $this->callBackUrl = JUri::root().'/index.php?option=com_j2store&view=checkout&task=confirmPayment&orderpayment_type=payment_pas&paction=callback';

    }

    public function _renderForm( $data )
    {
        $vars = new JObject();
        $vars->message = $this->params->get('pas_payment_message');
        $html = $this->_getLayout('form', $vars);
        return $html;
    }
	
	private function CurrencyAmount($amount)
    {
        $currency = $this->params->get('currency');
        if ($currency) 
		{ 
            $amount *= 10;
        }
        return $amount;
    }
	
    public function _prePayment($data)
    {
		require_once (JPATH_SITE.DS.'plugins'.DS.'j2store'.DS.'payment_pas'.DS.'paslibs'.DS.'paslibs.php');
		
        $vars = new StdClass();
        $vars->display_name = $this->params->get('display_name', '');
        $vars->onbeforepayment_text = '  پرداخت  ';

        $amount = $this->CurrencyAmount($data['orderpayment_amount']);
        $amount = (int)$amount;
        $sahkey = trim($this->params->get('sahkey'));
		$html = pasClass::setPas($amount,'',$sahkey,$this->callBackUrl);
		if($html[0] != 1)
		{
			$vars->error = $html[1];
		}else
		{
			$vars->token = $html[1];
			$vars->terminal = $sahkey;
		}
		$html = $this->_getLayout('prepayment', $vars);
		
        return $html;
    }

    public function _postPayment($data)
    {
		require_once (JPATH_SITE.DS.'plugins'.DS.'j2store'.DS.'payment_pas'.DS.'paslibs'.DS.'paslibs.php');
        $vars = new JObject();

        $orderId = $data['order_id'];

        F0FTable::addIncludePath(JPATH_ADMINISTRATOR.'/components/com_j2store/tables');
        $order = F0FTable::getInstance('Order', 'J2StoreTable')->getClone();
        $order->load(array('order_id' => $orderId));

        if($order->load(array('order_id' => $orderId)))
		{

            $currency = J2Store::currency();
            $currencyValues= $this->getCurrency($order);
            $orderPaymentAmount = $currency->format($order->order_total, $currencyValues['currency_code'], $currencyValues['currency_value'], false);
            $orderPaymentAmount = (int)($orderPaymentAmount / 10);

            $order->add_history(JText::_('J2STORE_CALLBACK_RESPONSE_RECEIVED'));

            $merchantCode = $this->params->get('sahkey');

            $app = JFactory::getApplication();
            $authority = $app->input->getString('Authority');
		
			if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
			{
				$db = JFactory::getDbo();
				$query = $db->getQuery(true);
				 $query->select(array('COUNT(*)'))->from($db->quoteName('#__j2store_orders'))
				 ->where($db->quoteName('transaction_id') . ' LIKE '. $db->quote('%'.$_POST['digitalreceipt'].'%'));
				$db->setQuery($query);
				$results = $db->loadResult();
				if($results == 0)
				{
					 $payResult = pasClass::getPas($_POST,$merchantCode); 
				}else
				{
					$payResult[0] = 0;
					$payResult[1] = 'رسید قبلا استفاده شده است';
				}
			}
			else
			{
				$payResult[0] = 0;
				$payResult[1] = $_POST['respmsg'];
			}
           if($payResult[0])
			{
				$order->transaction_id = $payResult[2];
                $order->payment_complete();
                $order->empty_cart();
                $message = 'پرداخت شما با مبنا کارت موفق بود' . "\n";
                $message .= 'شماره پیگیری مبنا کارت:' . $payResult[2];
                $vars->message = $message;
                $html = $this->_getLayout('postpayment', $vars);
                return $html;
            }else
			{
				$vars->message = $payResult[1];
                $html = $this->_getLayout('postpayment', $vars);
                return $html;
			}

            $message = 'پرداخت شما با مبنا کارت ناموفق بود' . "\n";
            $message .= 'مشکل پیش آمده این است:';
            $message .=  $payResult[1]. "\n";
      
            $vars->message = $message;
            $html = $this->_getLayout('postpayment', $vars);
            return $html;

        }

        $vars->message = 'مشکلی در بارگذاری صفحه پیش آمده است';
        $html = $this->_getLayout('postpayment', $vars);
        return $html;
    }

}